/*-
 * ============LICENSE_START=======================================================
 * SDC
 * ================================================================================
 * Copyright (C) 2017 AT&T Intellectual Property. All rights reserved.
 * ================================================================================
 * Licensed under the Apache License, Version 2.0 (the "License");
 * you may not use this file except in compliance with the License.
 * You may obtain a copy of the License at
 * 
 *      http://www.apache.org/licenses/LICENSE-2.0
 * 
 * Unless required by applicable law or agreed to in writing, software
 * distributed under the License is distributed on an "AS IS" BASIS,
 * WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
 * See the License for the specific language governing permissions and
 * limitations under the License.
 * ============LICENSE_END=========================================================
 */

package org.openecomp.sdc.be.dao.utils;

import fj.data.Either;
import org.openecomp.sdc.common.util.MethodActivationStatusEnum;

public enum UserStatusEnum {
	ACTIVE, INACTIVE;

	public static Either<UserStatusEnum, MethodActivationStatusEnum> findByName(String name) {
		Either<UserStatusEnum, MethodActivationStatusEnum> result = Either.right(MethodActivationStatusEnum.NOT_FOUND);
		for (UserStatusEnum status : UserStatusEnum.values()) {
			if (status.name().equals(name)) {
				result = Either.left(status);
				break;
			}
		}
		return result;
	}
}
